Index: contrib/app_acct_tools/README
===================================================================
--- contrib/app_acct_tools/README	(revision 533)
+++ contrib/app_acct_tools/README	(revision 1228)
@@ -21,5 +21,5 @@
   * when a session is complete (STOP record received), it stores a session summary
   into the processed records table (see process_database.sql file for format). 
-  * It optionaly archives the processed records into a different table, before deleting them.
+  * It optionally archives the processed records into a different table, before deleting them.
   * It can also move records of unterminated sessions that are older than a configurable time 
   to an orphan_records table, so that they are not re-processed every time. 
Index: doc/app_acct.conf.sample
===================================================================
--- doc/app_acct.conf.sample	(revision 533)
+++ doc/app_acct.conf.sample	(revision 1228)
@@ -68,10 +68,10 @@
 
 # Timestamp_field:
-# Optionaly, you can specify a name of a field that will receive the value 'now' when a new record is inserted.
+# Optionally, you can specify a name of a field that will receive the value 'now' when a new record is inserted.
 # Default: no timestamp is inserted.
 # Example: Timestamp_field = "recorded_on";
 
 # Server_name_field:
-# Optionaly, you can specify a field which will receive the Diameter Identity of the local server for each record saved.
+# Optionally, you can specify a field which will receive the Diameter Identity of the local server for each record saved.
 # This is useful especially if you have several Accounting servers and want to check Load-Balancing behavior or so,
 # after aggregating all the data.
Index: doc/dbg_interactive.py.sample
===================================================================
--- doc/dbg_interactive.py.sample	(revision 1176)
+++ doc/dbg_interactive.py.sample	(revision 1228)
@@ -468,5 +468,5 @@
 mydwr.send()
 
-# Optionaly, a callback can be registered when a request is sent, with an optional object.
+# Optionally, a callback can be registered when a request is sent, with an optional object.
 # This callback takes the answer message as parameter and should return None or a message. (cf. fd_msg_send)
 def send_callback(msg, obj):
@@ -480,5 +480,5 @@
 mydwr.send(send_callback, some_object)
 
-# Again optionaly, a time limit can be specified in this case as follow:
+# Again optionally, a time limit can be specified in this case as follow:
 mydwr.send(send_callback, some_object, 10)
 # In that case, if no answer / error is received after 10 seconds (the value specified), 
Index: doc/test_app.conf.sample
===================================================================
--- doc/test_app.conf.sample	(revision 1214)
+++ doc/test_app.conf.sample	(revision 1228)
@@ -49,5 +49,5 @@
 #  - server is silent on message reception, only the activity summary is displayed every 30 seconds
 #  - client attempts to send as many messages as possible during 10 seconds and counts them.
-# The benchmark keyword can be followed optionaly by two integers:
+# The benchmark keyword can be followed optionally by two integers:
 #   duration is the time for the measurement, in seconds (default 10).
 #   concurrency is the number of messages that can be on the wire before waiting for an answer (default 100).
Index: libfdcore/messages.c
===================================================================
--- libfdcore/messages.c	(revision 1120)
+++ libfdcore/messages.c	(revision 1228)
@@ -336,5 +336,5 @@
 }
 
-/* Send a message and optionaly register a callback for an answer */
+/* Send a message and optionally register a callback for an answer */
 int fd_msg_send ( struct msg ** pmsg, void (*anscb)(void *, struct msg **), void * data )
 {
Index: libfdcore/sctp.c
===================================================================
--- libfdcore/sctp.c	(revision 1200)
+++ libfdcore/sctp.c	(revision 1228)
@@ -964,5 +964,5 @@
 }
 
-/* Retrieve streams information from a connected association -- optionaly provide the primary address */
+/* Retrieve streams information from a connected association -- optionally provide the primary address */
 int fd_sctp_get_str_info( int sock, uint16_t *in, uint16_t *out, sSS *primary )
 {