Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.c
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.c	(revision 1146)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.c	(revision 1120)
@@ -10341,29 +10341,4 @@
 
 	{
-		/* additional allowed AVPs */
-		struct dict_object *ccr;
-		CHECK_dict_search(DICT_COMMAND, CMD_BY_NAME, "Credit-Control-Request", &ccr);
-		struct local_rules_definition rules[] = 
-			{
-				{ { .avp_vendor = 10415, .avp_name = "AoC-Request-Type"}, RULE_OPTIONAL, -1, 1 },
-				{ { .avp_vendor = 10415, .avp_name = "Service-Information"}, RULE_OPTIONAL, -1, 1 },
-			};
-		PARSE_loc_rules(rules, ccr);
-        }
-
-	{
-		/* additional allowed AVPs */
-		struct dict_object *ccr;
-		CHECK_dict_search(DICT_COMMAND, CMD_BY_NAME, "Credit-Control-Answer", &ccr);
-		struct local_rules_definition rules[] = 
-			{
-				{ { .avp_vendor = 10415, .avp_name = "Low-Balance-Indication"}, RULE_OPTIONAL, -1, 1 },
-				{ { .avp_vendor = 10415, .avp_name = "Remaining-Balance"}, RULE_OPTIONAL, -1, 1 },
-				{ { .avp_vendor = 10415, .avp_name = "Service-Information"}, RULE_OPTIONAL, -1, 1 },
-			};
-		PARSE_loc_rules(rules, ccr);
-        }
-
-	{
 		struct dict_object *rule_avp;
 		struct dict_avp_request vpa;
@@ -10393,19 +10368,4 @@
 				{ { .avp_vendor = 0,     .avp_name = "CC-Output-Octets" }, RULE_OPTIONAL, -1, 1 },
 				{ { .avp_vendor = 0,     .avp_name = "CC-Service-Specific-Units" }, RULE_OPTIONAL, -1, 1 },
-			};
-			PARSE_loc_rules(rules, rule_avp);
-        }
-
-	{
-		struct dict_object *rule_avp;
-		struct dict_avp_request vpa;
-		vpa.avp_vendor = 10415;
-		vpa.avp_name = "Event-Type";
-		CHECK_dict_search(DICT_AVP, AVP_BY_NAME_AND_VENDOR, &vpa, &rule_avp);
-		struct local_rules_definition rules[] =
-			{
-				{ { .avp_vendor = 10415, .avp_name = "SIP-Method" }, RULE_OPTIONAL, -1, 1 },
-				{ { .avp_vendor = 10415, .avp_name = "Event" }, RULE_OPTIONAL, -1, 1 },
-				{ { .avp_vendor = 10415, .avp_name = "Expires" }, RULE_OPTIONAL, -1, 1 },
 			};
 			PARSE_loc_rules(rules, rule_avp);
@@ -10609,5 +10569,5 @@
 				{ { .avp_vendor = 10415, .avp_name = "3GPP-User-Location-Info" }, RULE_OPTIONAL, -1, 1 },
 				{ { .avp_vendor = 10415, .avp_name = "User-CSG-Information" }, RULE_OPTIONAL, -1, 1 },
-				{ { .avp_vendor = 5535,  .avp_name = "3GPP2-BSID" }, RULE_OPTIONAL, -1, 1 },
+				{ { .avp_vendor = 5535, .avp_name = "3GPP2-BSID" }, RULE_OPTIONAL, -1, 1 },
 				{ { .avp_vendor = 10415, .avp_name = "3GPP-RAT-Type" }, RULE_OPTIONAL, -1, 1 },
 				{ { .avp_vendor = 10415, .avp_name = "PS-Furnish-Charging-Information" }, RULE_OPTIONAL, -1, 1 },
Index: libfdcore/cnxctx.c
===================================================================
--- libfdcore/cnxctx.c	(revision 1145)
+++ libfdcore/cnxctx.c	(revision 1141)
@@ -1409,7 +1409,4 @@
 				break;
 
-			default:
-				fd_log_debug("\t - unknown session type (%d)", cred);
-
 		}                           /* switch */
 
Index: libfdcore/extensions.c
===================================================================
--- libfdcore/extensions.c	(revision 1144)
+++ libfdcore/extensions.c	(revision 1127)
@@ -129,5 +129,5 @@
 		if (li == &ext->chain) {
 			/* the dependency was not found */
-			LOG_F("Error: extension [%s] depends on [%s] which was not loaded first. Please fix your configuration file.",
+			TRACE_ERROR("Error: extension [%s] depends on [%s] which was not loaded first. Please fix your configuration file.",
 				ext->ext_name, ext->depends[i]);
 			return ESRCH;
@@ -166,10 +166,12 @@
 			/* An error occured */
 			LOG_F("Loading of extension %s failed: %s", ext->filename, dlerror());
+			#ifdef DEBUG
 			ext->handler = dlopen(ext->filename, RTLD_LAZY | RTLD_GLOBAL);
 			if (ext->handler) {
 				if (!check_dependencies(ext)) {
-					LOG_F("In addition, not all declared dependencies are satisfied (Internal Error!)");
+					TRACE_ERROR("In addition, not all declared dependencies are satisfied (Internal Error!)");
 				}
 			}
+			#endif /* DEBUG */
 			return EINVAL;
 		}